package jalview.ws.api;

import jalview.ws.params.ParamDatastoreI;

/**
 * Service UI Info { Action, Specific Name of Service, Brief Description }
 */

public class UIinfo
{
  private String ServiceType;

  public UIinfo(String serviceType, String action, String name,
          String description, String hosturl)
  {
    this.setServiceType(serviceType == null ? "" : serviceType);
    this.Action = action == null ? "" : action;
    this.description = description == null ? "" : description;
    this.Name = name == null ? "" : name;
    this.hostURL = hosturl;
  }

  /**
   * The type of analysis the service performs
   */
  public String getServiceType()
  {
    return ServiceType;
  }

  public void setServiceType(String serviceType)
  {
    ServiceType = serviceType;
  }

  /**
   * The action when the service performs the analysis
   */
  public String getAction()
  {
    return Action;
  }

  public void setAction(String action)
  {
    Action = action;
  }

  /**
   * name shown to user
   * 
   * @return
   */
  public String getName()
  {
    return Name;
  }

  public void setName(String name)
  {
    Name = name;
  }

  /**
   * Detailed description (may include references, URLs, html,etc)
   * 
   * @return
   */
  public String getDescription()
  {
    return description;
  }

  public void setDescription(String description)
  {
    this.description = description;
  }

  @Override
  public boolean equals(Object object)
  {
    if (object == null || !(object instanceof UIinfo))
    {
      return false;
    }
    UIinfo other = (UIinfo) object;

    return (ServiceType == null && other.getServiceType() == null
            || ServiceType != null && other.getServiceType() != null
                    && ServiceType.equals(other.getServiceType()))
            && (hostURL == null && other.getHostURL() == null
                    || hostURL != null && other.getHostURL() != null
                            && hostURL.equals(other.getHostURL()))
            && (Name == null && other.getName() == null
                    || Name != null && other.getName() != null
                            && Name.equals(other.getName()))
            && (Action == null && other.getAction() == null
                    || Action != null && other.getAction() != null
                            && Action.equals(other.getAction()))
            && (description == null && other.getDescription() == null
                    || description != null && other.getDescription() != null
                            && description.equals(other.getDescription()));
  }

  /**
   * @return short description of what the service will do
   */
  public String getActionText()
  {
    return getAction() + " with " + getName();
  }

  String Action;

  String Name;

  String description;

  String hostURL;

  public String getHostURL()
  {
    return hostURL;
  }

  public ParamDatastoreI getParamStore()
  {
    // TODO Auto-generated method stub
    return null;
  }

  /**
   * 
   * @return true if the service has parameters (ie is instance of
   *         jalview.ws.api.ServiceWithParameters)
   */
  public boolean hasParameters()
  {
    // TODO Auto-generated method stub
    return false;
  }

  private String docUrl = null;

  /**
   * set the URL that will be offered to show documentation for the service
   * 
   * @param url
   */
  public void setDocumentationUrl(String url)
  {
    docUrl = url;
  }

  public boolean hasDocumentationUrl()
  {
    return docUrl != null && docUrl.length() > 7;
  }

  public String getDocumentationUrl()
  {
    return docUrl;
  }
}